FIND_LIBRARY(BLAS_LIBRARIES   NAMES blas   PATHS ${BLASLAPACK_DIR} NO_DEFAULT_PATH)
FIND_LIBRARY(LAPACK_LIBRARIES NAMES lapack PATHS ${BLASLAPACK_DIR} NO_DEFAULT_PATH)

SET (BLAS_LIBRARIES   ${BLAS_LIBRARIES}   CACHE STRING "BLAS library" )
SET (LAPACK_LIBRARIES ${LAPACK_LIBRARIES} CACHE STRING "LAPACK library"   )


INCLUDE(FindPackageHandleStandardArgs)
find_package_handle_standard_args (BLASLAPACK DEFAULT_MSG BLAS_LIBRARIES LAPACK_LIBRARIES)

IF (BLASLAPACK_FOUND)

  MESSAGE(STATUS "BLAS and LAPACK have been found using BLASLAPACK_DIR=${BLASLAPACK_DIR}")
  MESSAGE(STATUS "BLAS_LIBRARIES   : ${BLAS_LIBRARIES}")
  MESSAGE(STATUS "LAPACK_LIBRARIES : ${LAPACK_LIBRARIES}")
  MARK_AS_ADVANCED(BLAS_LIBRARIES LAPACK_LIBRARIES)

ELSE()

  MESSAGE( FATAL_ERROR "BLAS and LAPACK could not be found in BLASLAPACK_DIR=${BLASLAPACK_DIR}")

ENDIF(BLASLAPACK_FOUND)
